## tao-pegtl 2.7.1

=== CMakeLists.txt ===
cmake_minimum_required (VERSION 3.3.0 FATAL_ERROR)

project (pegtl VERSION 2.7.1 LANGUAGES CXX)

# installation directories
set (PEGTL_INSTALL_INCLUDE_DIR "include" CACHE STRING "The installation include directory")
set (PEGTL_INSTALL_DOC_DIR "share/doc/tao/pegtl" CACHE STRING "The installation doc directory")
set (PEGTL_INSTALL_CMAKE_DIR "share/pegtl/cmake" CACHE STRING "The installation cmake directory")

# define a header-only library
add_library (pegtl INTERFACE)
add_library (taocpp::pegtl ALIAS pegtl)
target_include_directories (pegtl INTERFACE
  $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/include>
  $<INSTALL_INTERFACE:${PEGTL_INSTALL_INCLUDE_DIR}>
)

# features required by the PEGTL
target_compile_features (pegtl INTERFACE
  cxx_alias_templates
  cxx_auto_type
  cxx_constexpr
  cxx_decltype
  cxx_default_function_template_args
  cxx_defaulted_functions
  cxx_delegating_constructors
  cxx_deleted_functions
  cxx_explicit_conversions
  cxx_generalized_initializers
  cxx_inheriting_constructors
  cxx_inline_namespaces
  cxx_noexcept
  cxx_nonstatic_member_init
  cxx_nullptr
  cxx_range_for
  cxx_rvalue_references
  cxx_static_assert
  cxx_strong_enums
  cxx_template_template_parameters
  cxx_trailing_return_types
  cxx_uniform_initialization
  cxx_variadic_macros
  cxx_variadic_templates
)

# testing
enable_testing ()
option (PEGTL_BUILD_TESTS "Build test programs" ON)
if (PEGTL_BUILD_TESTS)
  add_subdirectory (src/test/pegtl)
endif ()

# examples
option (PEGTL_BUILD_EXAMPLES "Build example programs" ON)
if (PEGTL_BUILD_EXAMPLES)
  add_subdirectory (src/example/pegtl)
endif ()

# install and export target
install (TARGETS pegtl EXPORT pegtl-targets)

install (EXPORT pegtl-targets
  FILE pegtl-config.cmake
  NAMESPACE taocpp::
  DESTINATION ${PEGTL_INSTALL_CMAKE_DIR}
)

install (DIRECTORY include/ DESTINATION ${PEGTL_INSTALL_INCLUDE_DIR})
install (FILES LICENSE DESTINATION ${PEGTL_INSTALL_DOC_DIR})

=== Makefile ===
# The Art of C++
# Copyright (c) 2014-2018 Dr. Colin Hirsch and Daniel Frey
# Please see LICENSE for license or visit https://github.com/taocpp/PEGTL

.SUFFIXES:
.SECONDARY:

ifeq ($(OS),Windows_NT)
UNAME_S := $(OS)
ifeq ($(shell gcc -dumpmachine),mingw32)
MINGW_CXXFLAGS = -U__STRICT_ANSI__
endif
else
UNAME_S := $(shell uname -s)
endif

# For Darwin (Mac OS X / macOS) we assume that the default compiler
# clang++ is used; when $(CXX) is some version of g++, then
# $(CXXSTD) has to be set to -std=c++11 (or newer) so
# that -stdlib=libc++ is not automatically added.

ifeq ($(CXXSTD),)
CXXSTD := -std=c++11
ifeq ($(UNAME_S),Darwin)
CXXSTD += -stdlib=libc++
endif
endif

# Ensure strict standard compliance and no warnings, can be
# changed if desired.

CPPFLAGS ?= -pedantic
CXXFLAGS ?= -Wall -Wextra -Wshadow -Werror -O3 $(MINGW_CXXFLAGS)

CLANG_TIDY ?= clang-tidy

HEADERS := $(filter-out include/tao/pegtl/internal/endian_win.hpp include/tao/pegtl/internal/file_mapper_win32.hpp,$(shell find include -name '*.hpp')) $(filter-out src/test/pegtl/main.hpp,$(shell find src -name '*.hpp'))
SOURCES := $(shell find src -name '*.cpp')
DEPENDS := $(SOURCES:%.cpp=build/%.d)
BINARIES := $(SOURCES:%.cpp=build/%)

UNIT_TESTS := $(filter build/src/test/%,$(BINARIES))

.PHONY: all
all: compile check

.PHONY: compile
compile: $(BINARIES)

.PHONY: check
check: $(UNIT_TESTS)
	@set -e; for T in $(UNIT_TESTS); do echo $$T; $$T > /dev/null; done

build/%.valgrind: build/%
	valgrind --error-exitcode=1 --leak-check=full $<
	@touch $@

.PHONY: valgrind
valgrind: $(UNIT_TESTS:%=%.valgrind)
	@echo "All $(words $(UNIT_TESTS)) valgrind tests passed."

build/%.cppcheck: %.hpp
	cppcheck --error-exitcode=1 --inconclusive --force --std=c++11 $<
	@mkdir -p $(@D)
	@touch $@

.PHONY: cppcheck
cppcheck: $(HEADERS:%.hpp=build/%.cppcheck)
	@echo "All $(words $(HEADERS)) cppcheck tests passed."

build/%.clang-tidy: %
	$(CLANG_TIDY) -extra-arg "-Iinclude" -extra-arg "-std=c++11" -checks=*,-fuchsia-*,-google-runtime-references,-google-runtime-int,-google-readability-todo,-cppcoreguidelines-pro-bounds-pointer-arithmetic,-cppcoreguidelines-pro-bounds-array-to-pointer-decay,-hicpp-no-array-decay,-hicpp-signed-bitwise,-modernize-raw-string-literal,-misc-sizeof-expression -warnings-as-errors=* $< 2>/dev/null
	@mkdir -p $(@D)
	@touch $@

.PHONY: clang-tidy
clang-tidy: $(HEADERS:%=build/%.clang-tidy) $(SOURCES:%=build/%.clang-tidy)
	@echo "All $(words $(HEADERS) $(SOURCES)) clang-tidy tests passed."

.PHONY: clean
clean:
	@rm -rf build
	@find . -name '*~' -delete

build/%.d: %.cpp Makefile
	@mkdir -p $(@D)
	$(CXX) $(CXXSTD) -Iinclude $(CPPFLAGS) -MM -MQ $@ $< -o $@

build/%: %.cpp build/%.d
	$(CXX) $(CXXSTD) -Iinclude $(CPPFLAGS) $(CXXFLAGS) $< -o $@

ifeq ($(findstring $(MAKECMDGOALS),clean),)
-include $(DEPENDS)
endif

=== src/example/pegtl/CMakeLists.txt ===
cmake_minimum_required (VERSION 3.3.0 FATAL_ERROR)

set (example_sources
  abnf2pegtl.cpp
  analyze.cpp
  calculator.cpp
  chomsky_hierarchy.cpp
  csv1.cpp
  csv2.cpp
  dynamic_match.cpp
  hello_world.cpp
  indent_aware.cpp
  json_build_one.cpp
  json_build_two.cpp
  json_count.cpp
  json_parse.cpp
  lua53_parse.cpp
  modulus_match.cpp
  parse_tree.cpp
  proto3.cpp
  recover.cpp
  s_expression.cpp
  sum.cpp
  symbol_table.cpp
  unescape.cpp
  uri.cpp
  uri_trace.cpp
)

# file (GLOB ...) is used to validate the above list of test_sources
file (GLOB glob_example_sources RELATIVE ${CMAKE_CURRENT_LIST_DIR} *.cpp)

foreach (examplesourcefile ${example_sources})
  if (${examplesourcefile} IN_LIST glob_example_sources)
    list (REMOVE_ITEM glob_example_sources ${examplesourcefile})
  else ()
    message (SEND_ERROR "File ${examplesourcefile} is missing from src/example/pegtl")
  endif ()

  get_filename_component (exename ${examplesourcefile} NAME_WE)
  set (exename "pegtl-example-${exename}")
  add_executable (${exename} ${examplesourcefile})
  target_link_libraries (${exename} PRIVATE taocpp::pegtl)
  set_target_properties (${exename} PROPERTIES
    CXX_STANDARD 11
    CXX_STANDARD_REQUIRED ON
    CXX_EXTENSIONS OFF
  )
  if (MSVC)
    target_compile_options (${exename} PRIVATE /W4 /WX /utf-8)
  else ()
    target_compile_options (${exename} PRIVATE -pedantic -Wall -Wextra -Wshadow -Werror)
  endif ()
endforeach (examplesourcefile)

if (glob_example_sources)
  foreach (ignored_source_file ${glob_example_sources})
    message (SEND_ERROR "File ${ignored_source_file} in src/example/pegtl is ignored")
  endforeach (ignored_source_file)
endif ()

=== src/test/pegtl/CMakeLists.txt ===
cmake_minimum_required (VERSION 3.3.0 FATAL_ERROR)

set (test_sources
  actions_one.cpp
  actions_three.cpp
  actions_two.cpp
  analyze_cycles.cpp
  argv_input.cpp
  ascii_classes.cpp
  ascii_eol.cpp
  ascii_eolf.cpp
  ascii_forty_two.cpp
  ascii_identifier.cpp
  ascii_istring.cpp
  ascii_keyword.cpp
  ascii_shebang.cpp
  ascii_string.cpp
  ascii_three.cpp
  ascii_two.cpp
  contrib_alphabet.cpp
  contrib_integer.cpp
  contrib_if_then.cpp
  contrib_json.cpp
  contrib_parse_tree.cpp
  contrib_raw_string.cpp
  contrib_rep_one_min_max.cpp
  contrib_to_string.cpp
  contrib_tracer.cpp
  contrib_unescape.cpp
  contrib_uri.cpp
  data_cstring.cpp
  demangle.cpp
  file_cstream.cpp
  file_file.cpp
  file_istream.cpp
  file_mmap.cpp
  file_read.cpp
  internal_endian.cpp
  internal_file_mapper.cpp
  internal_file_opener.cpp
  pegtl_string_t.cpp
  position.cpp
  rule_action.cpp
  rule_apply0.cpp
  rule_apply.cpp
  rule_at.cpp
  rule_bof.cpp
  rule_bol.cpp
  rule_bytes.cpp
  rule_control.cpp
  rule_disable.cpp
  rule_enable.cpp
  rule_eof.cpp
  rule_failure.cpp
  rule_if_apply.cpp
  rule_if_must.cpp
  rule_if_must_else.cpp
  rule_if_then_else.cpp
  rule_list.cpp
  rule_list_must.cpp
  rule_list_tail.cpp
  rule_minus.cpp
  rule_must.cpp
  rule_not_at.cpp
  rule_opt.cpp
  rule_opt_must.cpp
  rule_pad.cpp
  rule_pad_opt.cpp
  rule_plus.cpp
  rule_rep.cpp
  rule_rep_max.cpp
  rule_rep_min.cpp
  rule_rep_min_max.cpp
  rule_rep_opt.cpp
  rule_require.cpp
  rule_seq.cpp
  rule_sor.cpp
  rule_star.cpp
  rule_star_must.cpp
  rule_state.cpp
  rule_success.cpp
  rule_try_catch.cpp
  rule_until.cpp
  tester.cpp
  uint16_general.cpp
  uint32_general.cpp
  uint64_general.cpp
  uint8_general.cpp
  utf16_general.cpp
  utf32_general.cpp
  utf8_general.cpp
)

# file (GLOB ...) is used to validate the above list of test_sources
file (GLOB glob_test_sources RELATIVE ${CMAKE_CURRENT_LIST_DIR} *.cpp)

foreach (testsourcefile ${test_sources})
  if (${testsourcefile} IN_LIST glob_test_sources)
    list (REMOVE_ITEM glob_test_sources ${testsourcefile})
  else ()
    message (SEND_ERROR "File ${testsourcefile} is missing from src/test/pegtl")
  endif ()

  get_filename_component (exename ${testsourcefile} NAME_WE)
  set (exename "pegtl-test-${exename}")
  add_executable (${exename} ${testsourcefile})
  target_link_libraries (${exename} PRIVATE taocpp::pegtl)
  set_target_properties (${exename} PROPERTIES
    CXX_STANDARD 11
    CXX_STANDARD_REQUIRED ON
    CXX_EXTENSIONS OFF
  )
  if (MSVC)
    target_compile_options (${exename} PRIVATE /W4 /WX /utf-8)
  else ()
    target_compile_options (${exename} PRIVATE -pedantic -Wall -Wextra -Wshadow -Werror)
  endif ()
  if (ANDROID)
    add_test (NAME ${exename} WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}/../../.. COMMAND ${CMAKE_COMMAND} -DANDROID_NDK=${ANDROID_NDK} "-DTEST_RESOURCES=src/test/pegtl/data;src/test/pegtl/file_data.txt;Makefile" -DTEST_RESOURCES_DIR=${CMAKE_CURRENT_SOURCE_DIR}/../../.. -DUNITTEST=${CMAKE_CURRENT_BINARY_DIR}/${exename} -DTEST_PARAMETER=-all -P ${CMAKE_CURRENT_SOURCE_DIR}/ExecuteOnAndroid.cmake)
  else ()
    add_test (NAME ${exename} WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}/../../.. COMMAND ${CMAKE_CURRENT_BINARY_DIR}/${exename})
  endif ()
endforeach (testsourcefile)

if (glob_test_sources)
  foreach (ignored_source_file ${glob_test_sources})
    message (SEND_ERROR "File ${ignored_source_file} in src/test/pegtl is ignored")
  endforeach (ignored_source_file)
endif ()

## tao-pegtl 2.7.0

=== debian/changelog ===
tao-pegtl (2.7.0-1) unstable; urgency=low

  * Initial release. Closes: #905853

 -- Birger Schacht <birger@rantanplan.org>  Tue, 07 Aug 2018 20:30:15 +0200

=== debian/control ===
Source: tao-pegtl
Section: libs
Priority: optional
Maintainer: Birger Schacht <birger@rantanplan.org>
Build-Depends: cmake, debhelper (>=11~)
Standards-Version: 4.2.0
Homepage: https://github.com/taocpp/PEGTL

Package: tao-pegtl-dev
Section: libdevel
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: Parsing Expression Grammar Template Library
 The Parsing Expression Grammar Template Library (PEGTL) is a zero-dependency
 C++11 header-only parser combinator library for creating parsers according to a
 Parsing Expression Grammar (PEG).

## tao-pegtl 2.7.1

=== debian/changelog ===
tao-pegtl (2.7.1-1) unstable; urgency=medium

  * Add a gitlab-ci.yml file
  * New upstream version 2.7.1
  * Add missing Vcs-* fields (Closes: #908458)

 -- Birger Schacht <birger@rantanplan.org>  Tue, 02 Oct 2018 16:32:14 +0200

=== debian/control ===
--- 
+++ 
@@ -3,12 +3,15 @@
 Priority: optional
 Maintainer: Birger Schacht <birger@rantanplan.org>
 Build-Depends: cmake, debhelper (>=11~)
-Standards-Version: 4.2.0
+Standards-Version: 4.2.1
 Homepage: https://github.com/taocpp/PEGTL
+Vcs-Browser: https://salsa.debian.org/bisco-guest/tao-pegtl
+Vcs-Git: https://salsa.debian.org/bisco-guest/tao-pegtl.git
 
 Package: tao-pegtl-dev
 Section: libdevel
-Architecture: any
+Architecture: all
+Multi-Arch: foreign
 Depends: ${misc:Depends}, ${shlibs:Depends}
 Description: Parsing Expression Grammar Template Library
  The Parsing Expression Grammar Template Library (PEGTL) is a zero-dependency

=== debian/rules ===
#!/usr/bin/make -f
# You must remove unused comment lines for the released package.
#export DH_VERBOSE = 1
#export DEB_BUILD_MAINT_OPTIONS = hardening=+all
#export DEB_CFLAGS_MAINT_APPEND  = -Wall -pedantic
#export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed

%:
	dh $@ --buildsystem=cmake

override_dh_auto_install:
	dh_auto_install
	find ./debian -type f -name "LICENSE" -delete
	find ./debian -type d -empty -delete

#override_dh_auto_configure:
#	dh_auto_configure -- \
#	      -DCMAKE_LIBRARY_ARCHITECTURE="$(DEB_TARGET_MULTIARCH)"

## tao-pegtl 2.8.1

=== debian/changelog ===
tao-pegtl (2.8.1-1) unstable; urgency=medium

  * New upstream release
  * d/control
   + Bumped standards version to 4.4.1 (no changes required to make
     package compliant)
   + Added Rules-Requires-Root: no
  * Drop unneeded variable from d/gitlab-ci.yml
  * Switch Build-Dependency from debhelper to debhelper-compat

 -- Birger Schacht <birger@rantanplan.org>  Fri, 04 Oct 2019 17:54:31 +0200

=== debian/control ===
--- 
+++ 
@@ -2,11 +2,12 @@
 Section: libs
 Priority: optional
 Maintainer: Birger Schacht <birger@rantanplan.org>
-Build-Depends: cmake, debhelper (>=11~)
-Standards-Version: 4.2.1
+Build-Depends: cmake, debhelper-compat (=12)
+Standards-Version: 4.4.1
 Homepage: https://github.com/taocpp/PEGTL
 Vcs-Browser: https://salsa.debian.org/bisco-guest/tao-pegtl
 Vcs-Git: https://salsa.debian.org/bisco-guest/tao-pegtl.git
+Rules-Requires-Root: no
 
 Package: tao-pegtl-dev
 Section: libdevel

## tao-pegtl 2.8.3

=== debian/changelog ===
tao-pegtl (2.8.3-3) unstable; urgency=medium

  * d/rules: force -Wno-error=type-limits to enable build with gcc 10
    (Closes: #978520)
  * d/control: bump standards-version to 4.5.1 (no changes required)

 -- Birger Schacht <birger@debian.org>  Wed, 30 Dec 2020 16:23:59 +0100

tao-pegtl (2.8.3-2) unstable; urgency=medium

  * Force the use of gcc-9 until upstream is ready for
    gcc-10 (Closes: #966856)
  * d/control
   + update maintainer address
   + bump debhelper-compat version
   + update Vcs-* URLs

 -- Birger Schacht <birger@debian.org>  Mon, 03 Aug 2020 17:28:34 +0200

tao-pegtl (2.8.3-1) unstable; urgency=medium

  * New upstream release
  * Add Repositoy and Repository-Browse to the upstream
    metadata file

 -- Birger Schacht <birger@rantanplan.org>  Mon, 04 May 2020 08:50:40 +0200

tao-pegtl (2.8.2-1) unstable; urgency=medium

  * New upstream release
  * d/control: Bump standards-version to 4.5.0 (no changes required)

 -- Birger Schacht <birger@rantanplan.org>  Sun, 05 Apr 2020 21:56:50 +0200

=== debian/control ===
--- 
+++ 
@@ -1,12 +1,13 @@
 Source: tao-pegtl
 Section: libs
 Priority: optional
-Maintainer: Birger Schacht <birger@rantanplan.org>
-Build-Depends: cmake, debhelper-compat (=12)
-Standards-Version: 4.4.1
+Maintainer: Birger Schacht <birger@debian.org>
+Build-Depends: cmake,
+               debhelper-compat (=13),
+Standards-Version: 4.5.1
 Homepage: https://github.com/taocpp/PEGTL
-Vcs-Browser: https://salsa.debian.org/bisco-guest/tao-pegtl
-Vcs-Git: https://salsa.debian.org/bisco-guest/tao-pegtl.git
+Vcs-Browser: https://salsa.debian.org/birger/tao-pegtl
+Vcs-Git: https://salsa.debian.org/birger/tao-pegtl.git
 Rules-Requires-Root: no
 
 Package: tao-pegtl-dev

=== debian/watch ===
# You must remove unused comment lines for the released package.
version=4
opts=filenamemangle=s/.+\/v?(\d\S+)\.tar\.gz/PEGTL-$1\.tar\.gz/ \
  https://github.com/taocpp/PEGTL/tags .*/v?(\d\S+)\.tar\.gz

## tao-pegtl 3.2.5

=== debian/changelog ===
tao-pegtl (3.2.5-2) unstable; urgency=medium

  * Upload to unstable

 -- Birger Schacht <birger@debian.org>  Sun, 03 Apr 2022 21:20:28 +0200

tao-pegtl (3.2.5-1) experimental; urgency=medium

  * New upstream release (Closes: #1000987)
  * Update year range in d/copyright stanza for debian/*
  * Bump standards-version to 4.6.0.1 (no changes required)
  * Add Bug-Database to d/upstream/metadata

 -- Birger Schacht <birger@debian.org>  Tue, 01 Mar 2022 10:27:36 +0100

=== debian/control ===
--- 
+++ 
@@ -4,7 +4,7 @@
 Maintainer: Birger Schacht <birger@debian.org>
 Build-Depends: cmake,
                debhelper-compat (=13),
-Standards-Version: 4.5.1
+Standards-Version: 4.6.0.1
 Homepage: https://github.com/taocpp/PEGTL
 Vcs-Browser: https://salsa.debian.org/birger/tao-pegtl
 Vcs-Git: https://salsa.debian.org/birger/tao-pegtl.git

=== debian/watch ===
# You must remove unused comment lines for the released package.
version=4
https://github.com/taocpp/PEGTL/tags .*/v?(\d\S+)\.tar\.gz

## tao-pegtl 3.2.6

=== debian/changelog ===
tao-pegtl (3.2.6-1) unstable; urgency=medium

  * New upstream release
  * Bump Standards-Version to 4.6.1.0 (no changes required)
  * Switch to gitmode in d/watch
  * Add upstream signing key

 -- Birger Schacht <birger@debian.org>  Mon, 04 Jul 2022 15:36:33 +0200

## tao-pegtl 3.2.7

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.8...3.19)

# Read version from version.hpp
file(READ "${CMAKE_CURRENT_LIST_DIR}/include/tao/pegtl/version.hpp" version_hpp_data)
string(REGEX MATCH "#define TAO_PEGTL_VERSION \"([^\"]+)\"" _ ${version_hpp_data})
set(PEGTL_VERSION "${CMAKE_MATCH_1}")

project(pegtl VERSION ${PEGTL_VERSION} LANGUAGES CXX)

set(PEGTL_IS_MAIN_PROJECT OFF)
if(CMAKE_CURRENT_SOURCE_DIR STREQUAL CMAKE_SOURCE_DIR)
  set(PEGTL_IS_MAIN_PROJECT ON)
endif()

if(PEGTL_HAS_PARENT)
  # Multiple versions of PEGTL can't co-exist
  if(NOT ${PROJECT_NAME}_VERSION STREQUAL ${PROJECT_VERSION})
    message(FATAL_ERROR "Multiple mismatched PEGTL versions")
  endif()

  # Only include if this is the first include
  if(NOT ${PROJECT_NAME}_DIR STREQUAL "${PROJECT_BINARY_DIR}")
    return()
  endif()
endif()

# Keep track of pegtl version
set(${PROJECT_NAME}_FOUND TRUE CACHE BOOL "" FORCE)
set(${PROJECT_NAME}_VERSION "${PROJECT_VERSION}" CACHE STRING "" FORCE)
set(${PROJECT_NAME}_DIR "${PROJECT_BINARY_DIR}" CACHE PATH "" FORCE)

mark_as_advanced(${PROJECT_NAME}_FOUND)
mark_as_advanced(${PROJECT_NAME}_VERSION)
mark_as_advanced(${PROJECT_NAME}_DIR)

# installation directories
set(PEGTL_INSTALL_INCLUDE_DIR "include" CACHE STRING "The installation include directory")
set(PEGTL_INSTALL_DOC_DIR "share/doc/tao/pegtl" CACHE STRING "The installation doc directory")
set(PEGTL_INSTALL_CMAKE_DIR "share/pegtl/cmake" CACHE STRING "The installation cmake directory")

# define a header-only library
add_library(pegtl INTERFACE)
add_library(taocpp::pegtl ALIAS pegtl)
target_include_directories(pegtl INTERFACE
  $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/include>
  $<INSTALL_INTERFACE:${PEGTL_INSTALL_INCLUDE_DIR}>
)

# require C++17
target_compile_features(pegtl INTERFACE cxx_std_17)

option(PEGTL_USE_BOOST_FILESYSTEM "Override the auto-detection of std::filesystem and use Boost.Filesystem" OFF)

# Try compiling a test program with std::filesystem or one of its alternatives
function(check_filesystem_impl FILESYSTEM_HEADER FILESYSTEM_NAMESPACE OPTIONAL_LIBS OUT_RESULT)
  set(TEST_FILE "test_${OUT_RESULT}.cpp")
  configure_file(.cmake/test_filesystem.cpp.in ${TEST_FILE} @ONLY)

  try_compile(TEST_RESULT
    ${CMAKE_CURRENT_BINARY_DIR}
    ${CMAKE_CURRENT_BINARY_DIR}/${TEST_FILE}
    CXX_STANDARD 17)

  if(NOT TEST_RESULT)
    # Retry with each of the optional libraries
    foreach(OPTIONAL_LIB IN LISTS OPTIONAL_LIBS)
      try_compile(TEST_RESULT
        ${CMAKE_CURRENT_BINARY_DIR}
        ${CMAKE_CURRENT_BINARY_DIR}/${TEST_FILE}
        LINK_LIBRARIES ${OPTIONAL_LIB}
        CXX_STANDARD 17)

      if(TEST_RESULT)
        # Looks like the optional library was required, go ahead and add it to the link options.
        message(STATUS "Adding ${OPTIONAL_LIB} to the PEGTL to build with ${FILESYSTEM_NAMESPACE}.")
        target_link_libraries(${PROJECT_NAME} INTERFACE ${OPTIONAL_LIB})
        break()
      endif()
    endforeach()
  endif()

  set(${OUT_RESULT} ${TEST_RESULT} PARENT_SCOPE)
endfunction()

if(PEGTL_USE_BOOST_FILESYSTEM)
  # Force the use of Boost.Filesystem: #include <boost/filesystem.hpp> // boost::filesystem
  find_package(Boost REQUIRED COMPONENTS filesystem)
  target_link_libraries(${PROJECT_NAME} INTERFACE Boost::filesystem)
  target_compile_definitions(${PROJECT_NAME} INTERFACE TAO_PEGTL_BOOST_FILESYSTEM)
else()
  # Try compiling a minimal program with each header/namespace, in order of preference:
  #   C++17: #include <filesystem> // std::filesystem
  #   Experimental C++17: #include <experimental/filesystem> // std::experimental::filesystem
  #   Boost.Filesystem: #include <boost/filesystem.hpp> // boost::filesystem
  check_filesystem_impl("filesystem" "std::filesystem" "stdc++fs;c++fs" STD_FILESYSTEM)
  if(STD_FILESYSTEM)
    message(STATUS "Using std::filesystem")
  else()
    check_filesystem_impl("experimental/filesystem" "std::experimental::filesystem" "stdc++fs;c++fs" STD_EXPERIMENTAL_FILESYSTEM)
    if(STD_EXPERIMENTAL_FILESYSTEM)
      target_compile_definitions(${PROJECT_NAME} INTERFACE TAO_PEGTL_STD_EXPERIMENTAL_FILESYSTEM)
      message(WARNING "Using std::experimental::filesystem as a fallback")
    else()
      find_package(Boost COMPONENTS filesystem)
      check_filesystem_impl("boost/filesystem.hpp" "boost::filesystem" Boost::filesystem BOOST_FILESYSTEM)
      if(BOOST_FILESYSTEM)
        target_compile_definitions(${PROJECT_NAME} INTERFACE TAO_PEGTL_BOOST_FILESYSTEM)
        message(WARNING "Using Boost.Filesystem as a fallback")
      else()
        message(FATAL_ERROR "PEGTL requires C++17, including an implementation of std::filesystem, which your compiler toolchain does not seem to support. You can try installing Boost.Filesystem as a temporary workaround, but there's no guarantee the PEGTL will keep working with your project. Consider upgrading your compiler toolchain or downgrading the PEGTL to the previous version.")
      endif()
    endif()
  endif()
endif()

# testing
option(PEGTL_BUILD_TESTS "Build test programs" ${PEGTL_IS_MAIN_PROJECT})
if(PEGTL_BUILD_TESTS)
  enable_testing()
  add_subdirectory(src/test/pegtl)
endif()

# examples
option(PEGTL_BUILD_EXAMPLES "Build example programs" ${PEGTL_IS_MAIN_PROJECT})
if(PEGTL_BUILD_EXAMPLES)
  add_subdirectory(src/example/pegtl)
endif()

# Make package findable
configure_file(.cmake/pegtl-config.cmake.in pegtl-config.cmake @ONLY)

# Ignore pointer width differences since this is a header-only library
unset(CMAKE_SIZEOF_VOID_P)

# Enable version checks in find_package
include(CMakePackageConfigHelpers)
write_basic_package_version_file(pegtl-config-version.cmake COMPATIBILITY SameMajorVersion)

# install and export target
install(TARGETS pegtl EXPORT pegtl-targets)

install(EXPORT pegtl-targets
  FILE pegtl-config.cmake
  NAMESPACE taocpp::
  DESTINATION ${PEGTL_INSTALL_CMAKE_DIR}
)

install(FILES ${CMAKE_CURRENT_BINARY_DIR}/pegtl-config-version.cmake DESTINATION ${PEGTL_INSTALL_CMAKE_DIR})
install(DIRECTORY include/ DESTINATION ${PEGTL_INSTALL_INCLUDE_DIR})
install(FILES LICENSE DESTINATION ${PEGTL_INSTALL_DOC_DIR})

export(EXPORT pegtl-targets
  FILE ${pegtl_BINARY_DIR}/pegtl-targets.cmake
  NAMESPACE taocpp::
)

=== Makefile ===
# The Art of C++
# Copyright (c) 2014-2022 Dr. Colin Hirsch and Daniel Frey
# Please see LICENSE for license or visit https://github.com/taocpp/PEGTL

.SUFFIXES:
.SECONDARY:

ifeq ($(OS),Windows_NT)
UNAME_S := $(OS)
ifeq ($(shell gcc -dumpmachine),mingw32)
MINGW_CXXFLAGS = -U__STRICT_ANSI__
endif
else
UNAME_S := $(shell uname -s)
endif

# For Darwin (Mac OS X / macOS) we assume that the default compiler
# clang++ is used; when $(CXX) is some version of g++, then
# $(CXXSTD) has to be set to -std=c++17 (or newer) so
# that -stdlib=libc++ is not automatically added.

ifeq ($(CXXSTD),)
CXXSTD := -std=c++17
ifeq ($(UNAME_S),Darwin)
CXXSTD += -stdlib=libc++
endif
endif

# Ensure strict standard compliance and no warnings, can be
# changed if desired.

CPPFLAGS ?= -pedantic
CXXFLAGS ?= -Wall -Wextra -Wshadow -Werror -O3 $(MINGW_CXXFLAGS)

HEADERS := $(shell find include -name '*.hpp')
SOURCES := $(shell find src -name '*.cpp')
DEPENDS := $(SOURCES:%.cpp=build/%.d)
BINARIES := $(SOURCES:%.cpp=build/%)

UNIT_TESTS := $(filter build/src/test/%,$(BINARIES))

.PHONY: all
all: compile check

.PHONY: compile
compile: $(BINARIES)

.PHONY: check
check: $(UNIT_TESTS)
	@set -e; for T in $(UNIT_TESTS); do echo $$T; $$T > /dev/null; done

.PHONY: clean
clean:
	@rm -rf build/*
	@find . -name '*~' -delete

build/%.d: %.cpp Makefile
	@mkdir -p $(@D)
	$(CXX) $(CXXSTD) -Iinclude $(CPPFLAGS) -MM -MQ $@ $< -o $@

build/%: %.cpp build/%.d
	$(CXX) $(CXXSTD) -Iinclude $(CPPFLAGS) $(CXXFLAGS) $< $(LDFLAGS) -o $@

.PHONY: amalgamate
amalgamate: build/amalgamated/pegtl.hpp

build/amalgamated/pegtl.hpp: $(HEADERS)
	@mkdir -p $(@D)
	@rm -rf build/include
	@cp -a include build/
	@rm -rf build/include/tao/pegtl/contrib/icu
	@sed -i -e 's%^#%//#%g' $$(find build/include -name '*.hpp')
	@sed -i -e 's%^//#include "%#include "%g' $$(find build/include -name '*.hpp')
	@for i in $$(find build/include -name '*.hpp'); do echo "#pragma once" >tmp.out; echo "#line 1" >>tmp.out; cat $$i >>tmp.out; mv tmp.out $$i; done
	@echo '#include "tao/pegtl.hpp"' >build/include/amalgamated.hpp
	@( cd build/include ; for i in tao/pegtl/contrib/*.hpp; do echo "#include \"$$i\""; done ) >>build/include/amalgamated.hpp
	@echo -e "/*\n\nWelcome to the Parsing Expression Grammar Template Library (PEGTL)." >$@
	@echo -e "See https://github.com/taocpp/PEGTL/ for more information, documentation, etc.\n" >>$@
	@echo -e "The library is licensed as follows:\n" >>$@
	@cat LICENSE >>$@
	@echo -e "\n*/\n" >>$@
	@( cd build/include ; g++ -E -C -nostdinc amalgamated.hpp ) >>$@
	@sed -i -e 's%^//#%#%g' $@
	@sed -i -e 's%^# \([0-9]* "[^"]*"\).*%#line \1%g' $@
	@sed -i -e 's%^// Copyright.*%%g' $@
	@sed -i -e 's%^// Please.*%%g' $@
	@echo "Generated/updated $@ successfully."

ifeq ($(findstring $(MAKECMDGOALS),clean),)
-include $(DEPENDS)
endif

=== debian/changelog ===
tao-pegtl (3.2.7-1) unstable; urgency=medium

  * New upstream release

 -- Birger Schacht <birger@debian.org>  Sat, 06 Aug 2022 16:12:35 +0200

=== debian/control ===
--- 
+++ 
@@ -4,7 +4,7 @@
 Maintainer: Birger Schacht <birger@debian.org>
 Build-Depends: cmake,
                debhelper-compat (=13),
-Standards-Version: 4.6.0.1
+Standards-Version: 4.6.1.0
 Homepage: https://github.com/taocpp/PEGTL
 Vcs-Browser: https://salsa.debian.org/birger/tao-pegtl
 Vcs-Git: https://salsa.debian.org/birger/tao-pegtl.git

=== debian/rules ===
#!/usr/bin/make -f

export DEB_CXXFLAGS_MAINT_APPEND += -Wno-error=type-limits

%:
	dh $@ --buildsystem=cmake

override_dh_auto_install:
	dh_auto_install
	find ./debian -type f -name "LICENSE" -delete
	find ./debian -type d -empty -delete

=== debian/watch ===
version=4
opts="mode=git,pgpmode=gittag" \
https://github.com/taocpp/PEGTL refs/tags/([\d\.]+)
